// ---------------------------------------------------------------------------
//   ..
//        .
//
//   2.0:   .
//   3.0:    .
// ---------------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_width1  2
#property indicator_color1  Red
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_level1  75
#property indicator_level2  50
#property indicator_level3  25

//  .
extern int PERIOD = 4;

//  .
double buf[], buf_av[];
//   .
int work_period;

// .
int init() {
  IndicatorShortName("AZZX - CLOSE POSITION v3.0 (" + PERIOD + ")");
  IndicatorBuffers(2);
  IndicatorDigits(0);
  
  SetIndexBuffer(0, buf_av);
  SetIndexEmptyValue(0, -1);
  SetIndexLabel(0, "AVERAGE POSITION");
  
  SetIndexBuffer(1, buf);

  work_period = Bars - PERIOD;
  
  return(0);
}

//  .
int start() {
  for(int i = Bars - IndicatorCounted() - 1; i >= 0; i--) {
    if(High[i] != Low[i]) {
      buf[i] = (Close[i] - Low[i]) / (High[i] - Low[i]) * 100;
    } else {
      buf[i] = 50;
    }
    
    if(i < work_period) {
      double v = 0;
      int    j;
      
      for(j = i + PERIOD - 1; j >= i; j--) {
        v += buf[j];
      }
    
      buf_av[i] = v / PERIOD;
    } else {
      buf_av[i] = -1;
    }
  }

  return(0);
}

